###########################################################################################
#                                                                                         #
# This is my channel script                                                               #
# Version 0.5.3                                                                           #
# Written by BrianM@dial.pipex.com                                                        #
#                                                                                         #
# If you have any comments or ideas on how to enhance this script then please dont        #
# hesitate to contact me on the above email address.                                      #
#                                                                                         #
# Please Note:                                                                            #
#                                                                                         #
#  This is my FIRST tcl/eggdrop script ever! so there may be better/easier/correct ways   #
#  todo the things in this script, if you know how todo this then please email me on the  #
#  above address and I will give you credit in the next released version.                 #
#                                                                                         #
###########################################################################################
#                                                                                         #
# Installation Instructions:                                                              #
#                                                                                         #
#  To install this script all you have todo is make sure that you are using at least      #
#  eggdrop 1.3.0 (I have 1.3.8+aarownl+reaper-savefix patch, tcl 8.0p2), in your eggdrop  #
#  config file just add a line like below                                                 #
#                                                                                         #
#     source scripts/channel.tcl                                                          #
#                                                                                         #
#  And of course copy this script into the scripts directory!!                            #
#                                                                                         #
#  You can also change the command char, eg change !voice to @voice etc                   #
#                                                                                         #
###########################################################################################
#                                                                                         #
# Thanks to the following :                                                               #
#  Marcin Kulas [hitower@heros.juni.gliwice.pl] for suggesting that I dont respond to     #
#  unknown users.                                                                         #
#                                                                                         #
#  Garry Wellman [netman@netman.org] for suggesting that I enable user to select the      #
#  command char                                                                           #
#                                                                                         #
###########################################################################################
#                                                                                         #
# Version Histroy:                                                                        #
#                                                                                         #
#    0.5.0 (xx/1/98) - Initial Release                                                    #
#    0.5.1 (xx/1/98) - Changed so that bot dosent respond to unknown users                #
#    0,5.2 (xx/1/98) - Fixed the unix utils so they work with <nick|ip|dns> correctly and #
#                        remove extra messages to channels                                #
#    0.5.3 (20/1/98) - Added the option to change the command char                        #
#                                                                                         #
###########################################################################################

if {![info exists numversion] || ($numversion < 1030000)} {
  putlog "*** Can't load channel script -- At least Eggdrop v1.3.0 required"
  return 0
}

putlog "Channel script version 0.5.3 by |SmUrF| loaded"
putlog "use !help in channel for comands."

###########################################################################################
#                                                                                         #
# Change the character below to change the command character                              #
#                                                                                         #
###########################################################################################
proc commandchar {} {
	return "!"
}

bind join * * onjoin
bind pub - [commandchar]voice voice
bind pub - [commandchar]devoice devoice 
bind pub - [commandchar]op op
bind pub - [commandchar]deop deop
bind pub - [commandchar]kick kick
bind pub - [commandchar]ban ban
bind pub - [commandchar]unban unban
bind pub - [commandchar]kickban kickban
bind pub - [commandchar]topic topic
bind pub - [commandchar]help help
bind pub - [commandchar]search search
bind pub - [commandchar]addsearch addsearch
bind pub - [commandchar]nslookup nslookup
bind pub - [commandchar]finger finger
bind pub - [commandchar]ping ping
bind pub - [commandchar]whois whois
bind pub - [commandchar]traceroute traceroute
bind pub - [commandchar]dig dig

proc voice {nick host hand chan text} {
	global botnick
	set hostmask "$text![getchanhost $text $chan]"
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			if {$botnick == $text} {
				putserv "privmsg $nick : You cant change the bots flags !!"
			} else {
				if {[onchan $text $chan] == 0} {
					putserv "privmsg $nick : $text is not on $chan !!"
				} else {
					if {[validuser $text] == 0} {
						adduser $text $hostmask
						set newattr [chattr $text +v $chan]
					} else {
						if {[matchattr $text +v $chan] == 1} {
						} else {
							set newattr [chattr $text +v $chan]
						}
					}
					putserv "MODE $chan +v $text"
				}
			}
		} else {
			putserv "privmsg $nick : BOT IS NOT AN OP !!!"
		}
	}
}
proc devoice {nick host hand chan text} {
	global botnick
	set hostban "$text![getchanhost $text $chan]"
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			if {$botnick == $text} {
				putserv "privmsg $nick : You cant change the bots flags !!"
			} else {
				if {[onchan $text $chan] == 0} {
					putserv "privmsg $nick : $text is not on $chan !!"
				} else {
					if {[validuser $text] == 0} {
						adduser $text $hostmask
						set newattr [chattr $text -v $chan]
					} else {
						if {[matchattr $text -v $chan] == 1} {
						} else {
							set newattr [chattr $text -v $chan]
						}
					}
					putserv "MODE $chan -v $text"
				}
			}
		} else {
			putserv "privmsg $nick : BOT IS NOT AN OP !!!"
		}
	}
}
proc op {nick host hand chan text} {
	global botnick
	set hostmask "$text![getchanhost $text $chan]"
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			if {$botnick == $text} {
				putserv "privmsg $nick : You cant change the bots flags !!"
			} else {
				if {[onchan $text $chan] == 0} {
				} else {
					if {[validuser $text] == 0} {
						adduser $text $hostmask
						set newattr [chattr $text +o $chan]
					} else {
						if {[matchattr $text +o $chan] == 1} {
						} else {
							set newattr [chattr $text +o $chan]
						}
					}
					putserv "MODE $chan +o $text"
				}
			}
		} else {
			putserv "privmsg $chan : BOT IS NOT AN OP !!!"
		}
	}
}
proc deop {nick host hand chan text} {
	global botnick
	set hostban "$text![getchanhost $text $chan]"
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			if {$botnick == $text} {
				putserv "privmsg $chan : You cant change the bots flags !!"
			} else {
				if {[onchan $text $chan] == 0} {
					putserv "privmsg $chan : $text is not on $chan !!"
				} else {
					if {[validuser $text] == 0} {
						adduser $text $hostmask
						set newattr [chattr $text -o $chan]
					} else {
						if {[matchattr $text -o $chan] == 1} {
						} else {
							set newattr [chattr $text -o $chan]
						}
					}
					putserv "MODE $chan -o $text"
				}
			}
		} else {
			putserv "privmsg $chan : BOT IS NOT AN OP !!!"
		}
	}
}
proc kick {nick host hand chan text} {
	global botnick
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			set whom [lindex $text 0]
			set reason [lrange $text 1 end]
			if {$botnick == $whom} {
				putserv "privmsg $chan : You cant change the bots flags !!"
			} else {
				if {[onchan $whom $chan] == 0} {
				} else {
					putserv "KICK $chan $whom : $reason"
				}
			}
		} else {
			putserv "privmsg $chan : BOT IS NOT AN OP !!!"
		}
	}
}
proc ban {nick host hand chan text} {
	global botnick
	set whom [lindex $text 0]
	set lifetime [lindex $text 1]
	set reason [lrange $text 2 end]
	set hostban "$whom![getchanhost $whom $chan]"
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			if {$botnick == $whom} {
				putserv "privmsg $chan : You cant change the bots flags !!"
			} else {
				if {[onchan $whom $chan] == 0} {
					putserv "privmsg $chan : $whom is not on $chan !!"
				} else {
					if {[validuser $whom] == 0} {
						adduser $whom $hostmask
						set newattr [chattr $whom +k-ov $chan]
					} else {
						if {[matchattr $whom +k $chan] == 1} {
						} else {
							set newattr [chattr $whom +k-ov $chan]
						}
					}
					newchanban $chan $hostban $nick $reason $lifetime
					putserv "MODE $chan +b $hostban"
				}
			}
		} else {
			putserv "privmsg $chan : BOT IS NOT AN OP !!!"
		}
	}
}
proc unban {nick host hand chan text} {
	global botnick
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			if {[ischanban $text $chan] == 1} {
				set whom [finduser $text]
				if {[validuser $whom] == 0} {
				} else {
					if {[matchattr $whom -k $chan] == 1} {
					} else {
						set newattr [chattr $whom -k $chan]
					}
				}
				killchanban $chan $text
				putserv "MODE $chan -b $text"
			} else {
				putserv "privmsg $nick : $text is not in the ban list !"
			}
		} else {
			putserv "privmsg $chan : BOT IS NOT AN OP !!!"
		}
	}
}
proc kickban {nick host hand chan text} {
	global botnick
	set whom [lindex $text 0]
	set lifetime [lindex $text 1]
	set reason [lrange $text 2 end]
	set hostban "$whom![getchanhost $whom $chan]"
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			if {$botnick == $whom} {
				putserv "privmsg $chan : You cant change the bots flags !!"
			} else {
				if {[onchan $whom $chan] == 0} {
				} else {
					if {[validuser $whom] == 0} {
						adduser $whom $hostmask
						set newattr [chattr $whom +k-ov $chan]
					} else {
						if {[matchattr $whom +k $chan] == 1} {
						} else {
							set newattr [chattr $whom +k-ov $chan]
						}
					}
					newchanban $chan $hostban $nick $reason $lifetime
					putserv "KICK $chan $whom : $reason"
				}
			}
		} else {
			putserv "privmsg $chan : BOT IS NOT AN OP !!!"
		}
	}
}
proc topic {nick host hand chan text} {
	global botnick
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[botisop $chan] == 1} {
			putserv "TOPIC $chan :$text"
		} else {
			putserv "privmsg $chan : BOT IS NOT AN OP !!!"
		}
	}
}
proc help {nick host hand chan text} {
	putserv "privmsg $nick : Here is the current options"
	if {[matchattr $nick +o $chan] == 0} {
		putserv "privmsg $nick : [commandchar]help - Sends help"
		putserv "privmsg $nick : [commandchar]search - NOT WORKING"
		putserv "privmsg $nick : [commandchar]addsearch - NOT WORKING"
	} else {
		putserv "privmsg $nick : [commandchar]op <nick> - Gives <nick> ops (+o) in current channel"
		putserv "privmsg $nick : [commandchar]deop <nick> - Removed <nick> ops (-o) in current channel"
		putserv "privmsg $nick : [commandchar]voice <nick> - Gives <nick> voice (+v) in current channel"
		putserv "privmsg $nick : [commandchar]devoice <nick> - Removes <nick> voice (-v) in current channel"
		putserv "privmsg $nick : [commandchar]kick <nick> <reason> - Kicks <nick> from current channel with reason <reason>"
		putserv "privmsg $nick : [commandchar]ban <nick> <mins> <reason> - Bans <nick> from current channel with reason <reason> for <mins> minutes"
		putserv "privmsg $nick : [commandchar]unban <hostmask> - Unbans <hostmask> from current channel"
		putserv "privmsg $nick : [commandchar]kickban <nick> <mins> <reason> - Kicks and bans <nick> with reason <reason> for <mins> minutes"
		putserv "privmsg $nick : [commandchar]topic <topic> - Changes topic to <topic> on current channel"
		putserv "privmsg $nick : [commandchar]help - Sends help"
		putserv "privmsg $nick : [commandchar]search - NOT WORKING"
		putserv "privmsg $nick : [commandchar]addsearch - NOT WORKING"
		putserv "privmsg $nick : [commandchar]ping <nick|ip|dns> - Pings <nick|ip|dns>"
		putserv "privmsg $nick : [commandchar]nslookup <nick|ip|dns> - Does a Name Server (DNS) Lookup on <nick|ip|dns>"
		putserv "privmsg $nick : [commandchar]traceroute <nick|ip|dns> - Does a Traceroute on <nick|ip|dns>"
		putserv "privmsg $nick : [commandchar]whois <nick|ip|dns> - Does a Whois on <nick|ip|dns>"
		putserv "privmsg $nick : [commandchar]dig <nick|ip|dns> - Does a dig on <nick|ip|dns>"
		putserv "privmsg $nick : [commandchar]finger <nick|ip|dns> - Does a Finger on <nick|ip|dns>"
	}
}
proc search {nick host hand chan text} {
	putserv "privmsg $nick : This function is not functional yet! (sorry)"
}
proc addsearch {nick host hand chan text} {
	putserv "privmsg $nick : This function is not functional yet! (sorry)"
}
proc onjoin {nick host hand chan} {
	global botnick
	if {$botnick == $nick} {
	} else {
		if {[validuser $nick] == 1} {
			if {[passwdok "$hand" ""] == "1"} {
				putlog "$nick ($hand) Does Not Have A Password Set.  /msg $nick."
				putserv "privmsg $nick :You Don't Have A Password Set On Me.  Please One Set One Now By Typing: /msg $botnick pass <PASSWORD>"
			}
		}
		putserv "privmsg $chan : Welcome $nick to $chan, if you have any questions plese /msg an operator (people with @ to the left of their nick!)"
	}
}
proc nslookup {nick host hand chan text} {
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[onchan $text $chan] == 1} {
			set host [lindex [split [getchanhost $text $chan] @] 1]
		} else {
			set host $text
		}
		set input [open "|nslookup $host" r]
		set trash [gets $input]
		set trash [gets $input]
		while {![eof $input]} {
			catch {set contents [gets $input]}
			putserv "PRIVMSG $nick :$contents"
		}
		catch {close $input}
	}
}
proc finger {nick host hand chan text} {
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[onchan $text $chan] == 1} {
			set host [lindex [split [getchanhost $text $chan] @] 1]
		} else {
			set host $text
		}
		set input [open "|finger $host" r]
		set trash [gets $input]
		set trash [gets $input]
		while {![eof $input]} {
		        catch {set contents [gets $input]}
		        putserv "PRIVMSG $nick :$contents"
	        }
		catch [close $input]
	}
}
proc ping {nick host hand chan text} {
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[onchan $text $chan] == 1} {
			set host [lindex [split [getchanhost $text $chan] @] 1]
		} else {
			set host $text
		}
		set input [open "|ping -c4 -s1024 $host" r]
		while {![eof $input]} {
	        	catch {set contents [gets $input]}
		        putserv "PRIVMSG $nick :$contents"
        	}
		catch [close $input]
	}
}
proc whois {nick host hand chan text} {
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[onchan $text $chan] == 1} {
			set host [lindex [split [getchanhost $text $chan] @] 1]
		} else {
			set host $text
		}
		set input [open "|whois $host" r]
		while {![eof $input]} {
			catch {set contents [gets $input]}
		  	putserv "PRIVMSG $nick :$contents"
 		}
		catch {close $input}
	}
}
proc traceroute {nick host hand chan text} {
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[onchan $text $chan] == 1} {
			set host [lindex [split [getchanhost $text $chan] @] 1]
		} else {
			set host $text
		}
		set input [open "|traceroute $host" r]
		while {![eof $input]} {
		        catch {set contents [gets $input]}
		        putserv "PRIVMSG $nick :$contents"
	        }
		catch {close $input}
	}
}
proc dig {nick host hand chan text} {
	if {[matchattr $nick +o $chan] == 0} {
	} else {
		if {[onchan $text $chan] == 1} {
			set host [lindex [split [getchanhost $text $chan] @] 1]
		} else {
			set host $text
		}
		set input [open "|dig $host" r]
		while {![eof $input]} {
			set output [set output [gets $input]]
			putserv "PRIVMSG $nick :$output"
		}
		close $input
	}
}